import { ClientQueryParamsType, ClientResponseType, QueryStringifyOptions } from "../client";
import { CommandInstance } from "../command";
import { NegativeTypes } from "../types";
import { RequestInterceptorCallback, ResponseInterceptorCallback } from "./builder.types";
export declare const stringifyValue: (response: string | unknown) => string;
export declare const interceptRequest: (interceptors: RequestInterceptorCallback[], command: CommandInstance) => Promise<CommandInstance>;
export declare const interceptResponse: <GlobalErrorType>(interceptors: ResponseInterceptorCallback[], response: ClientResponseType<any, GlobalErrorType>, command: CommandInstance) => Promise<ClientResponseType<any, GlobalErrorType>>;
export declare const getClientHeaders: (command: CommandInstance) => HeadersInit;
export declare const getClientPayload: (data: unknown) => string | FormData;
export declare const stringifyQueryParams: (queryParams: ClientQueryParamsType | string | NegativeTypes, options?: QueryStringifyOptions) => string;
