import EventEmitter from "events";
import { CacheValueType } from "./";
export declare const getCacheEvents: (emitter: EventEmitter) => {
    /**
     * Set cache data
     * @param cacheKey
     * @param data
     */
    emitCacheData: <Response_1, Error_1>(cacheKey: string, data: CacheValueType<Response_1, Error_1>) => void;
    /**
     * Revalidate cache values event
     */
    emitRevalidation: (cacheKey: string) => void;
    /**
     * Cache data listener
     * @param cacheKey
     * @param callback
     * @returns
     */
    onData: <Response_2, Error_2>(cacheKey: string, callback: (data: CacheValueType<Response_2, Error_2>) => void) => VoidFunction;
    /**
     * Cache invalidation listener
     * @param cacheKey
     * @param callback
     * @returns
     */
    onRevalidate: (cacheKey: string, callback: () => void) => VoidFunction;
};
