import { Dispatcher } from "./";
import { CommandDump, CommandInstance } from "../command";
export declare type DispatcherOptionsType = {
    storage?: DispatcherStorageType;
    onInitialization?: (dispatcherInstance: Dispatcher) => void;
    onUpdateStorage?: <Command extends CommandInstance>(queueKey: string, data: DispatcherData<Command>) => void;
    onDeleteFromStorage?: <Command extends CommandInstance>(queueKey: string, data: DispatcherData<Command>) => void;
    onClearStorage?: (dispatcherInstance: Dispatcher) => void;
};
export declare type DispatcherDumpValueType<Command extends CommandInstance = CommandInstance> = {
    requestId: string;
    commandDump: CommandDump<Command>;
    retries: number;
    timestamp: number;
    stopped: boolean;
};
export declare type DispatcherData<Command extends CommandInstance = CommandInstance> = {
    requests: DispatcherDumpValueType<Command>[];
    stopped: boolean;
};
export declare type DispatcherStorageType = {
    set: <Command extends CommandInstance = CommandInstance>(key: string, data: DispatcherData<Command>) => void;
    get: <Command extends CommandInstance = CommandInstance>(key: string) => DispatcherData<Command> | undefined;
    keys: () => string[] | IterableIterator<string>;
    delete: (key: string) => void;
    clear: () => void;
};
export declare type RunningRequestValueType = {
    requestId: string;
    command: CommandInstance;
};
