/// <reference types="node" />
import EventEmitter from "events";
import { BuilderInstance } from "../../builder";
import { LoggerType, SeverityType, LoggerOptionsType, LoggerFunctionType } from "./..";
/**
 * This class is used across the Hyper Fetch library to provide unified logging system with necessary setup per each builder.
 * We can set up the logging level based on available values. This manager enable to initialize the logging instance per individual module
 * like Builder, Command etc. Which can give you better feedback on the logging itself.
 */
export declare class LoggerManager {
    private builder;
    private options?;
    logger: LoggerFunctionType;
    severity: SeverityType;
    emitter: EventEmitter;
    constructor(builder: BuilderInstance, options?: LoggerOptionsType);
    setSeverity: (severity: SeverityType) => void;
    init: (module: string) => LoggerType;
}
