import { ClientResponseType } from "../../client";
import { CommandInstance } from "../../command";
import { CommandResponseDetails } from "../command";
export declare type SeverityType = 0 | 1 | 2 | 3;
export declare type LoggerType = Record<LoggerLevelType, (message: LoggerMessageType, ...additionalData: LoggerMessageType[]) => void>;
export declare type LoggerFunctionType = (log: LogType) => void;
export declare type LoggerOptionsType = {
    logger?: LoggerFunctionType;
    severity?: SeverityType;
};
export declare type LogType = {
    module: string;
    level: LoggerLevelType;
    message: LoggerMessageType;
    additionalData?: LoggerMessageType[];
    enabled: boolean;
    severity: SeverityType;
};
export declare type LoggerLevelType = "error" | "warning" | "info" | "debug";
export declare type LoggerMessageType = string | Record<string, unknown> | Array<unknown>;
export declare type LoggerRequestEventData = {
    requestId: string;
    command: CommandInstance;
};
export declare type LoggerResponseEventData = {
    requestId: string;
    command: CommandInstance;
    response: ClientResponseType<unknown, unknown>;
    details: CommandResponseDetails;
};
